﻿Type=StaticCode
Version=2.52
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim settingsFileName As String = "MultiClickerSettings.txt"
	Dim soundFlag As Boolean = True
End Sub

Sub playPrimaryActionSound
	If soundFlag = True Then
		Main.clickSound.navDownFx(1)			'primary-action sound
	End If
End Sub

Sub playSecondaryActionSound
	If soundFlag = True Then
		Main.clickSound.returnFx(1)			'secondary-action sound
	End If
End Sub

Sub adjustSoundVolume(volumeChangeArg As Int)		'~save/load volume for next session? preserve system's volume on app entry/exit?
	Dim phone1 As Phone
	phone1.SetVolume(phone1.VOLUME_SYSTEM, phone1.GetVolume(phone1.VOLUME_SYSTEM) + volumeChangeArg, True)
	Return True
End Sub

Sub loadSettingsFromMapFile
	Dim counterTotal, i As Int
	Dim numberSuffix As String
	Dim settingsMap As Map : settingsMap.Initialize
	If File.Exists(File.DirInternal, settingsFileName) Then
		settingsMap = File.ReadMap(File.DirInternal, settingsFileName)
		soundFlag = settingsMap.GetDefault("soundFlag", True)
		counterTotal = settingsMap.GetDefault("counterTotal", 0)
		Log("Loaded counterTotal = " & counterTotal)
		If counterTotal > 0 Then
			Main.currentCounterIndex = settingsMap.GetDefault("lastCurrentCounter", -1)		'no current = -1
			For i = 0 To (counterTotal - 1)
				numberSuffix = NumberFormat(i, 3, 0)			'e.g. "001"
				Dim tempCounter As Counter
				tempCounter.Initialize
				tempCounter.name = settingsMap.Get("name" & numberSuffix)
				tempCounter.maxCount = settingsMap.Get("maxCount" & numberSuffix)
				tempCounter.count = settingsMap.Get("count" & numberSuffix)
				tempCounter.updatedDateTime = settingsMap.Get("updatedDateTime" & numberSuffix)
				Main.counterList.Add(tempCounter)
			Next
		End If
	End If
End Sub

Sub saveSettingsToMapFile
	Dim i As Int
	Dim numberSuffix As String
	Dim settingsMap As Map : settingsMap.Initialize
	settingsMap.Put("soundFlag", soundFlag)
	settingsMap.Put("counterTotal", Main.counterList.Size)
	Log("Saved counterTotal = " & Main.counterList.Size)
	settingsMap.Put("lastCurrentCounter", Main.currentCounterIndex)
	Log("Saved lastCurrentCounter = " & Main.currentCounterIndex)
	For i = 0 To (Main.counterList.Size - 1)
		Dim tempCounter As Counter		
		tempCounter.Initialize
		tempCounter = Main.counterList.get(i)
		numberSuffix = NumberFormat(i, 3, 0)			'e.g. "001"
		settingsMap.Put("name" & numberSuffix, tempCounter.name)
		settingsMap.Put("maxCount" & numberSuffix, tempCounter.maxCount)
		settingsMap.Put("count" & numberSuffix, tempCounter.count)
		settingsMap.Put("updatedDateTime" & numberSuffix, tempCounter.updatedDateTime)
	Next
	File.WriteMap(File.DirInternal, settingsFileName, settingsMap)
End Sub

