﻿Type=Activity
Version=2.52
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: False
	#IncludeTitle: False
#End Region

'Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim currentCounter As Counter : currentCounter.Initialize
	Dim titlePanel As Panel
	Dim deleteButton As Button
	Dim resetButton As Button
	Dim soundButton As Button
	Dim nameLabel As Label
	Dim valueLabel As Label
	Dim minusButton As Button
	Dim plusButton As Button
	Dim updatedLabel As Label
	Dim appImage As ImageView
	Dim previousButton As Button
	Dim nameField As EditText
	Dim cdPrimaryEnabled, cdPrimaryPressed, cdPrimaryFocused, cdSecondaryEnabled, cdSecondaryPressed, cdSecondaryFocused, cdSecondaryDisabled As ColorDrawable
	Dim cdSoundEnabled, cdSoundPressed, cdSoundMutedEnabled, cdSoundMutedPressed As BitmapDrawable
   Dim sldPrimary, sldSecondary, sldSound As StateListDrawable
	Dim buttonCornerRadius As Int = 10dip
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("counterDetail")
	defineButtonDrawables
	adjustColors
End Sub

Sub Activity_Resume
	Log("resume - currentCounterIndex = " & Main.currentCounterIndex)
	If Main.currentCounterIndex >= 0 Then
		currentCounter = Main.counterList.Get(Main.currentCounterIndex)
		nameLabel.Text = currentCounter.name
		updateCounter
		updateSecondaryButtons
		updateDateLabel(currentCounter.updatedDateTime)
		adjustPlusMinusButtons
		updateSoundButton
	Else
		Activity.Finish
	End If
	'~if editing name on orientation change, preserve current nameField value 
End Sub

Sub Activity_Pause(UserClosed As Boolean)
	Dim ime1 As IME
	ime1.HideKeyboard
	common.saveSettingsToMapFile
	If UserClosed = True Then
		Main.currentCounterIndex = -1
	End If
End Sub

Sub activity_KeyPress(KeyCode As Int) As Boolean
	If KeyCode = KeyCodes.KEYCODE_BACK Then
	 	If nameField.Visible = True Then
			commitNameChange
			Return True				'consume the event so we stay on the same screen
		End If
		'otherwise we return to the home screen normally
	Else If KeyCode = KeyCodes.KEYCODE_DPAD_CENTER Then		'if nothing is focused, make the primary the default action
		If currentCounter.maxCount = 0 Then		'plus is primary
			plusButton_Click							'~ideally would also show button pressed state (possible without a timer kludge?)
		Else
			minusButton_Click
		End If
		Return True
	Else If KeyCode = KeyCodes.KEYCODE_VOLUME_UP Then
		common.adjustSoundVolume(1)
		Return True
	Else If KeyCode = KeyCodes.KEYCODE_VOLUME_DOWN Then
		common.adjustSoundVolume(-1)
		Return True
	End If
End Sub

Sub defineButtonDrawables
	cdPrimaryPressed.Initialize(Colors.RGB(75, 228, 75), buttonCornerRadius)
	cdPrimaryFocused.Initialize(Colors.RGB(125, 228, 125), buttonCornerRadius)
	cdPrimaryEnabled.Initialize(Colors.RGB(175, 228, 175), buttonCornerRadius)		
	cdSecondaryPressed.Initialize(Colors.RGB(228, 75, 75), buttonCornerRadius)
	cdSecondaryFocused.Initialize(Colors.RGB(228, 125, 125), buttonCornerRadius)
	cdSecondaryEnabled.Initialize(Colors.RGB(228, 175, 175), buttonCornerRadius)
	cdSecondaryDisabled.Initialize(Colors.RGB(200, 200, 200), buttonCornerRadius)
	cdSoundPressed.Initialize(LoadBitmap(File.DirAssets, "sound-pressed.png"))
	cdSoundPressed.Gravity = Gravity.FILL
'	cdSoundFocused.Initialize(LoadBitmap(File.DirAssets, "soundDark.png"))
'	cdSoundFocused.Gravity = Bit.OR(Gravity.CENTER_VERTICAL, Gravity.CENTER)
	cdSoundEnabled.Initialize(LoadBitmap(File.DirAssets, "sound.png"))		
	cdSoundEnabled.Gravity = Gravity.FILL
	cdSoundMutedEnabled.Initialize(LoadBitmap(File.DirAssets, "sound-muted.png"))		
	cdSoundMutedEnabled.Gravity = Gravity.FILL
	cdSoundMutedPressed.Initialize(LoadBitmap(File.DirAssets, "sound-muted-pressed.png"))
	cdSoundMutedPressed.Gravity = Gravity.FILL
'	cdSoundMutedFocused.Initialize(LoadBitmap(File.DirAssets, "soundMutedDark.png"))
'	cdSoundMutedFocused.Gravity = Bit.OR(Gravity.CENTER_VERTICAL, Gravity.CENTER)
   sldPrimary.Initialize
	sldPrimary.AddState(sldPrimary.State_Pressed, cdPrimaryPressed)
	sldPrimary.AddState(sldPrimary.State_Focused, cdPrimaryFocused)
	sldPrimary.AddState(sldPrimary.State_Enabled, cdPrimaryEnabled)
   sldSecondary.Initialize
	sldSecondary.AddState(sldSecondary.State_Pressed, cdSecondaryPressed)
	sldSecondary.AddState(sldSecondary.State_Focused, cdSecondaryFocused)
	sldSecondary.AddState(sldSecondary.State_Disabled, cdSecondaryDisabled)
	sldSecondary.AddState(sldSecondary.State_Enabled, cdSecondaryEnabled)
End Sub

'use "light" colors - they show up better in sunlight
Sub adjustColors
	Activity.Color = Colors.RGB(238, 238, 238)
	titlePanel.Color = Colors.RGB(221, 221, 221)
End Sub

'make the primary button bigger (e.g. the plus button for a count-up counter)
Sub adjustPlusMinusButtons
	Dim primaryHeight As Float = 56
	Dim secondaryHeight As Float = 28
	Dim availableButtonHeight As Int
	If Activity.Height > Activity.Width Then		'portrait
		availableButtonHeight = (updatedLabel.Top) - (valueLabel.top + valueLabel.Height + 32dip) - 16dip
		plusButton.Top = valueLabel.top + valueLabel.Height + 32dip
		If currentCounter.maxCount = 0 Then		'count up
			plusButton.Height = availableButtonHeight * .66
			minusButton.Height = availableButtonHeight * .33
		Else												' count down
			plusButton.Height = availableButtonHeight * .33
			minusButton.Height = availableButtonHeight * .66
		End If
		minusButton.top = plusButton.Top + plusButton.Height + 16dip
	Else														'landscape
		availableButtonHeight = (100%y - 16dip) - (titlePanel.top + titlePanel.Height + 16dip) - 16dip
		plusButton.Top = titlePanel.top + titlePanel.Height + 16dip
		If currentCounter.maxCount = 0 Then		'count up
			plusButton.Height = availableButtonHeight * .66
			minusButton.Height = availableButtonHeight * .33
		Else												' count down
			plusButton.Height = availableButtonHeight * .33
			minusButton.Height = availableButtonHeight * .66
		End If
		minusButton.top = plusButton.Top + plusButton.Height + 16dip
	End If
	If currentCounter.maxCount = 0 Then		'count up
		plusButton.Background = sldPrimary
		plusButton.TextSize = primaryHeight
		minusButton.Background = sldSecondary
		minusButton.TextSize = secondaryHeight
	Else
		plusButton.Background = sldSecondary
		plusButton.TextSize = secondaryHeight
		minusButton.Background = sldPrimary
		minusButton.TextSize = primaryHeight
	End If
End Sub

Sub plusButton_Click
	If currentCounter.maxCount > 0 Then		'count-down
		common.playSecondaryActionSound
	Else
		common.playPrimaryActionSound
	End If
	currentCounter.count = currentCounter.count + 1
	updateCounter
	updateSecondaryButtons
	currentCounter.updatedDateTime = DateTime.Now
	updateDateLabel(currentCounter.updatedDateTime)
End Sub

Sub minusButton_Click
	If currentCounter.maxCount > 0 Then		'count-down
		common.playPrimaryActionSound
	Else
		common.playSecondaryActionSound
	End If
	currentCounter.count = currentCounter.count - 1
	updateCounter
	updateSecondaryButtons
	currentCounter.updatedDateTime = DateTime.Now
	updateDateLabel(currentCounter.updatedDateTime)
	If (currentCounter.maxCount > 0) AND (currentCounter.count = 0) Then		'count-down timer reaches zero
		Msgbox("Done! Count will be reset.", "")
		resetCurrentCounter
	End If
End Sub

Sub updateCounter
	valueLabel.Text = currentCounter.count
End Sub

Sub updateSecondaryButtons
	If currentCounter.maxCount > 0 Then		'count down
		plusButton.Enabled = (currentCounter.count < currentCounter.maxCount)
	Else												'count up
		minusButton.Enabled = currentCounter.count > 0
	End If
End Sub

Sub updateDateLabel(dateArg As Long)
	Dim dateString As String
	If dateArg = 0 Then
		updatedLabel.Text = ""
	Else
		If DateTime.Date(dateArg) = DateTime.Date(DateTime.Now) Then
			dateString = "Today"
		Else If DateTime.Date(dateArg) = DateTime.Date(DateTime.Add(DateTime.Now, 0, 0, -1)) Then
			dateString = "Yesterday"
		Else
			dateString = DateTime.date(dateArg)
		End If
		updatedLabel.Text = "Updated:  " & dateString
	End If
End Sub

Sub previousButton_Click
	Activity.Finish
End Sub

Sub deleteButton_Click	
	If Msgbox2("Delete this counter?", "", "Delete", "Cancel", "", Null) = DialogResponse.POSITIVE Then
		Main.counterList.RemoveAt(Main.currentCounterIndex)
		Activity.Finish
		ToastMessageShow("Counter deleted.", False)
	End If
End Sub

Sub resetButton_Click
	'~add tooltip on long-click of icon buttons
	If Msgbox2("Reset this counter to " & currentCounter.maxCount & "?", "", "Reset", "Cancel", "", Null) = DialogResponse.POSITIVE Then
		resetCurrentCounter
	End If
End Sub

Sub resetCurrentCounter
	currentCounter.count = currentCounter.maxCount
	updateCounter
	updateSecondaryButtons
	updateDateLabel(0)
End Sub

Sub nameLabel_Click
	nameField.Text = nameLabel.Text
	nameLabel.Visible = False
	nameField.enabled = True
	nameField.Visible = True
	Dim ime1 As IME
	ime1.ShowKeyboard(nameField)
End Sub

Sub nameField_EnterPressed
	commitNameChange
End Sub

Sub commitNameChange
	If nameField.Text <> "" Then
		nameLabel.Text = nameField.Text
		currentCounter.name = nameField.Text
		nameField.Visible = False
		nameField.enabled = False
		nameLabel.Visible = True
	End If
End Sub

Sub soundButton_Click
	common.soundFlag = Not(common.soundFlag)
	updateSoundButton
	common.playPrimaryActionSound
End Sub

Sub updateSoundButton
	sldSound.Initialize
	If common.soundFlag = True Then
		sldSound.AddState(sldSound.State_Pressed, cdSoundPressed)
'		sldSound.AddState(sldSound.State_Focused, cdSoundFocused)
		sldSound.AddState(sldSound.State_Enabled, cdSoundEnabled)
	Else
		sldSound.AddState(sldSound.State_Pressed, cdSoundMutedPressed)
'		sldSound.AddState(sldSound.State_Focused, cdSoundMutedFocused)
		sldSound.AddState(sldSound.State_Enabled, cdSoundMutedEnabled)
	End If
	soundButton.Background = sldSound
End Sub