﻿Type=Activity
Version=2.52
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: False
	#IncludeTitle: False
#End Region

'Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim tempName, tempRadio, tempMax As String
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim titlePanel As Panel
	Dim saveButton As Button				'~get proper disabled image
	Dim cancelButton As Button
	Dim countUpRadio As RadioButton
	Dim countDownRadio As RadioButton
	Dim nameText As EditText
	Dim maxCountText As EditText
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("newCounter")
	adjustColors
End Sub

Sub Activity_Resume
	'load any temp values from orientation changes
	nameText.Text = tempName
	If tempRadio = "up" Then
		countUpRadio.Checked = True
	Else If tempRadio = "down" Then
		countDownRadio.Checked = True
	End If
	maxCountText.Text = tempMax
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	'save current form values on orientation change
	tempName = nameText.Text
	If countUpRadio.Checked = True Then
		tempRadio = "up"
	Else If countDownRadio.Checked = True Then
		tempRadio = "down"
	Else
		tempRadio = ""
	End If
	tempMax = maxCountText.Text
End Sub

Sub activity_KeyPress(KeyCode As Int) As Boolean
	If KeyCode = KeyCodes.KEYCODE_VOLUME_UP Then
		common.adjustSoundVolume(1)
		Return True
	Else If KeyCode = KeyCodes.KEYCODE_VOLUME_DOWN Then
		common.adjustSoundVolume(-1)
		Return True
	End If
End Sub

Sub adjustColors
	Activity.Color = Colors.RGB(238, 238, 238)
	titlePanel.Color = Colors.RGB(221, 221, 221)
End Sub

Sub nameText_TextChanged (Old As String, New As String)
	updateSaveButton
End Sub

Sub radio_CheckedChange(Checked As Boolean)
	maxCountText.Visible = countDownRadio.Checked
	updateSaveButton
End Sub

Sub updateSaveButton
	saveButton.Enabled = (nameText.Text <> "") AND ((countUpRadio.Checked = True) OR ((countDownRadio.Checked = True) AND maxCountText.Text <> ""))
End Sub

Sub maxCountText_TextChanged (Old As String, New As String)
	updateSaveButton
End Sub

Sub saveButton_Click
	Dim tempCounter As Counter		
	tempCounter.Initialize
	tempCounter.name = nameText.Text
	If countDownRadio.Checked Then
		tempCounter.maxCount = maxCountText.Text
		tempCounter.count = tempCounter.maxCount
	Else
		tempCounter.maxCount = 0
		tempCounter.count = 0
	End If
	tempCounter.updatedDateTime = 0
	Main.counterList.Add(tempCounter)
	Main.currentCounterIndex = Main.counterList.Size - 1
	StartActivity("counterDetail")
	Activity.Finish
End Sub

Sub cancelButton_Click
	Dim ime1 As IME
	ime1.HideKeyboard
	Activity.Finish
End Sub

